<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>List students</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body>
    <div class="container w-50">
        <div class="text-center m-3">
            <h3>THÔNG TIN SINH VIÊN</h3>
        </div>
        <div class="row form-group">
            <div class="col-sm-3">
                <button class="btn btn-primary" onclick="onGetStudentListClick()">Lấy thông tin</button>
            </div>
            <label class="col-form-label col-sm-4">Số lượng sinh viên: 
                <span id="span-num-students" class="text-danger font-weight-bold">1000</span>
            </label>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">Danh sách ID sinh viên: 
                <span id="span-id-student-list" class="text-danger">3, 4, 7, 8, 9, 10</span>
            </div>
        </div>
        <br><hr>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-student-id">Nhập Id sinh viên <span class="text-danger">(*)</span></label>
            <div class="col-sm-5">
                <input id="input-student-id" placeholder="Nhập id sinh viên ..." class="form-control">
            </div>
            <div class="col-sm-3">
                <button class="btn btn-primary" onclick="onXemChiTietClick()">Xem chi tiết</button>
            </div>
        </div>
        <hr>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-student-code">Student Code</label>
            <div class="col-sm-3">
                <input id="input-student-code" placeholder="Student Code" class="form-control">
            </div>
            <label class="col-form-label col-sm-3" for="input-username">Username</label>
            <div class="col-sm-3">
                <input id="input-username" placeholder="Username" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-firstname">First name</label>
            <div class="col-sm-3">
                <input id="input-firstname" placeholder="First name" class="form-control">
            </div>
            <label class="col-form-label col-sm-3" for="input-lastname">Last name</label>
            <div class="col-sm-3">
                <input id="input-lastname" placeholder="Last name" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-birthday">Birthday</label>
            <div class="col-sm-3">
                <input type="text" id="input-birthday" placeholder="Birthday" class="form-control">
            </div>
            <label class="col-form-label col-sm-3" for="input-study-year">Study year</label>
            <div class="col-sm-3">
                <input type="text" id="input-study-year" placeholder="Study year" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-3" for="input-email">Email</label>
            <div class="col-sm-9">
                <input type="text" id="input-email" placeholder="Email" class="form-control">
            </div>
        </div>
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;

    var gBASE_URL = "https://624abe0dfd7e30c51c110ac6.mockapi.io/api/v1/";


    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
   // API lấy danh sách sinh viên (Students) và  ấn nút Lấy Thông
   function onGetStudentListClick() {
        var vAPI_URL = gBASE_URL + "/students";
        var vXhttp = new XMLHttpRequest();
        vXhttp.open("GET", vAPI_URL, false);
        vXhttp.send();
        if (vXhttp.status == gREQUEST_STATUS_OK) {
            console.log(vXhttp.responseText);
        }

        listAllStudents(vXhttp);
    }


    //ấn nút Xem chi tiết
    function onXemChiTietClick() {
        var vUser = {
            id: ""
        }
        //Bước 1: Đọc
        readDataFromWeb(vUser);
        //Bước 2: Kiểm tra
        var vKetQuaKiemTra = validate(vUser);
        if (vKetQuaKiemTra == true) {
            // Bước 3: gọi API
            onGetStudentByIdClick(vUser);
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm đọc thông tin
    function readDataFromWeb(paramObjUser) {
        var vElementInput = document.getElementById("input-student-id");
        var vValueInput = vElementInput.value;
        paramObjUser.id = vValueInput;
    }

    // Hàm Validate
    function validate(paramObjUser) {
        if (paramObjUser.id ===  ""){
            alert("Enter ID!");
            return false;
        }
        var vCheckSo = isNaN(paramObjUser.id);
        if (vCheckSo) {
            alert("ID must be a number!");
            return false;
        }
        return true;
    }

    // API lấy chi tiết 01 sinh viên by id
    function onGetStudentByIdClick() {
        const vAPI_URL = gBASE_URL + "/students/";
        var vStudentId = 2;

        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET", vAPI_URL + vStudentId, false);
        vXmlHttp.send();
        if (vXmlHttp.status == gREQUEST_STATUS_OK) {
            console.log(vXmlHttp.responseText);
             // Bước 4: xử lý hiển thị
             hienThiDuLieuLenWeb(vXmlHttp);
        } else {
            alert("Cannot find User with entered ID!");
        }
    }

    // Hiển thị dữ liệu lên web
    function hienThiDuLieuLenWeb(paramXhttp) {
        var vUserObject = JSON.parse(paramXhttp.responseText);
        var vElementStudentCode = document.getElementById("input-student-code");
        var vElementUserName = document.getElementById("input-username");
        var vElementFirstName = document.getElementById("input-firstname");
        var vElementLastName = document.getElementById("input-lastname");
        var vElementBirthday = document.getElementById("input-birthday");
        var vElementStudyYear = document.getElementById("input-study-year");
        var vElementEmail = document.getElementById("input-email");
        
        vElementStudentCode.value = vUserObject.studentCode;
        vElementUserName.value = vUserObject.username;
        vElementFirstName.value = vUserObject.firstname;
        vElementLastName.value = vUserObject.lastname;
        vElementBirthday.value = vUserObject.birthday;
        vElementStudyYear.value = vUserObject.studyYear;
        vElementEmail.value = vUserObject.email;
    }

    //hàm hiển thị toàn bộ danh sách học sinh
    function listAllStudents(paramXML) {
        //  nhận về response và xử lý
        var vStatusCode = paramXML.status;
        //  nếu trạng thái trả về thành công
        if(vStatusCode == gREQUEST_STATUS_OK) {
            // nhận lại response dạng JSON ở xmlHttp.responseText và chuyển thành object
            var bResponse = JSON.parse(paramXML.responseText);
            //Truy xuất form thông tin người dùng thông qua id
            var vNumberOfStudents = document.getElementById("span-num-students");
            var vListStudents = document.getElementById("span-id-student-list");
            //số lượng học sinh
            vNumberOfStudents.innerHTML = bResponse.length;
            //líst id học sinh
            var vLitsIdSpan = bResponse[0].id;
            for (bI = 1; bI < bResponse.length; bI++) {
                vLitsIdSpan += ", " + bResponse[bI].id;
            }
            vListStudents.innerHTML = vLitsIdSpan;
        }
    }
</script>

</html>